import 'package:battleships/logger.dart';
import 'package:battleships/game.dart';

void main (List<String> arguments) {
	//usage:
	//	without arguments: 	default size and loglevel
	//	one argument: 		sets size, default loglevel (0<integer)
	//	two arguments:		sets size and loglevel 		(0<=integer<=3, 0 is minimum, 3 is maximum)	


	//Set console output level
	if(arguments != null && arguments.length > 1 && arguments[1] != null) {
		try {
			int loglevel = int.parse(arguments[1]);
			LOGLEVEL lvl = Logger.IntToLoglevel(loglevel);
			if(lvl == null) {
				throw("");
			}
			Logger.SetLogLevelS(lvl);
		} catch(exception, stackTrace) {
			Logger.PrintS(LOGLEVEL.MINIMAL, "Invalid LOGLEVEL argument, aborting.");
			return;
		}
	} else {
		Logger.SetLogLevelS(LOGLEVEL.NORMAL);
	}

	//Battlefield size, highly recommended not touching that
	//Random generators are bad, so it may not even start the game 
	int battlefieldSize = 10;
	if(arguments != null && arguments[0] != null) {
		try {
			battlefieldSize = int.parse(arguments[0]);
		} catch(exception, stackTrace) {
			Logger.PrintS(LOGLEVEL.MINIMAL, "Invalid SIZE argument, aborting.");
			return;
		}
	}
	new Game(battlefieldSize).Start();
}