import './ship.dart';
import 'dart:io';
import 'dart:math';


enum SEASTAT {
	HIT, 	//ship
	WATER,	//nothing
	NOTDISC	//TBD
}

/**
 * Helper class
 */
class Position{
	final int x;
	final int y;
	const Position(this.x, this.y);
}

/**
 * Very unnecessary class
 * just to test heredity
 */
class GameBoard {
	int size;
	GameBoard(this.size){}
}

/**
 * Player board class keeps track of players ships, their placement and map of hits
 */
class PlayerBoard extends GameBoard {
	List<Ship> _ships = new List<Ship>();
	List<List<SEASTAT>> possiblePositions;


	PlayerBoard(int size):super(size){
		// Do not work :-(
		// creates just one instance of List<SEASTAT>
		// possiblePositions = new List<List<SEASTAT>>.filled(size, new List<SEASTAT>.filled(size, SEASTAT.NOTDISC));

		
		possiblePositions = new List<List<SEASTAT>>(size);
		for(int i = 0; i < size; ++i) {
			possiblePositions[i] = new List<SEASTAT>(size);
			for(int j = 0; j < size; ++j) {
				possiblePositions[i][j] = SEASTAT.NOTDISC;
			}
		}
	}

	/**
	 * Getter for ship list
	 */
	List<Ship> GetShips() {
		return _ships;
	}

	/**
	 * Validate and save ship, false if fail
	 */
	bool AddShip(Ship s) {
		if(this.Colides_S(s)) {
			return false;
		}
		for(var ship in _ships) {
			if(ship.Colides_S(s)) {
				return false;
			}
		}
		_ships.add(s);
		return true;
	}

	//Helper method, ships collision
	bool Colides_S(Ship s){
		return this.Colides_R(s.dimensions);
	}

	//Helper method, rectangle collision
	bool Colides_R(Rectangle r) {
		Rectangle tmp = new Rectangle(0, 0, size, size);
		return !tmp.containsRectangle(r);
	}

	/**
	 * Returns free coordinates
	 * (may be randommed)
	 */
	Position GetFreePosition(int width, int height) {
		Random rng = new Random();
		int i,j;
		//1 to {size} chance to get randomed starting indexes
		if(rng.nextInt(size)==0){
			i = rng.nextInt(size-width-1);
			j = rng.nextInt(size-height-1);			
		} else {
			i = 0;
			j = 0;
		}

		for(int i = 0; i < size-width; ++i) {
			for(int j = 0; j < size-height; ++j) {
				int posX = j;
				int posY = i;
				//1 to {size} chance to get random position
				//roll it high baby
				if(rng.nextInt(size)==0){
					posX += rng.nextInt((size/3).round());
					posY += rng.nextInt((size/3).round());
				}
				Rectangle r = new Rectangle(posX, posY, width, height);
				if(this.Colides_R(r)) {
					continue;
				}
				bool error = false; 
				for(var ship in _ships) {
					if(ship.Colides_R(r)) {
						error = true;
						break;
					}
				}
				if(error) {
					continue;
				}
				return new Position(posX, posY);
			}
		}
		return null;
	}

	/**
	 * Prints out gameboard
	 */
	Print(){
		print("Water: '+' | Undiscovered: '#'");
		List<List<bool>> arr = new List<List<bool>>(size);
		for(int i = 0; i < size; ++i) {
			arr[i] = new List<bool>(size);
		}
		for(var ship in _ships) {
			ship.PrintToArr(arr);
		}

		for(int i = 0; i < size; ++i){
			for(int j = 0; j < size; ++j){
				if(arr[i][j]){
					stdout.write('*');					
				} else {
					stdout.write('+');
				}	
			}
			stdout.write('\n');
		}
	}

	/**
	 * Prints out map
	 */
	PrintPossiblePositions() {
		print("Water: '+' | Ship: '*' | Undiscovered: '#'");
		for(int i = 0; i < size; ++i) {
			for(int j = 0; j < size; ++j) {
				if(possiblePositions[i][j] == SEASTAT.WATER) {
					stdout.write('+');
				} else if(possiblePositions[i][j] == SEASTAT.HIT) {
					stdout.write('*');
				} else {
					stdout.write('#');
				}
			}
			stdout.write('\n');
		}
	}
}

