import './logger.dart';
import 'dart:math';
import 'dart:io';


class Ship {
	Rectangle dimensions;
	int _health;
	int _maxHealth;
	Ship(x, y, width, height) {
		dimensions = new Rectangle(x, y, width, height);
		_health = width*height;
		_maxHealth = _health;
	}

	int GetHealth() {
		return _health;
	}

	int GetMaxHealth() {
		return _maxHealth;
	}

	bool IsSink() {
		return _health == 0;
	}

	bool Hit() {
		--_health;
	}

	bool Colides_S(Ship s){
		return s.dimensions.intersects(this.dimensions);
	}

	bool Colides_R(Rectangle r){
		return r.intersects(this.dimensions);
	}

	String toString() {
		return "${dimensions.width}x${dimensions.height}";
	}

	void PrintToArr(List<List<bool>> list) {
		for(int i = 0; i < dimensions.height; ++i) {
			for(int j = 0; j < dimensions.width; ++j) {
				list[this.dimensions.top+i][this.dimensions.left+j] = true;
			}
		}
	}
}

class Forces {
	List<Ship> ships = new List<Ship>();
	Forces(){}
	void Generate(size) {
		//rules
		//max size of single ship
		int maxSize = size - (size/7).round();
		//number of ships
		int count = size*0.5;

		//randomly randomize random numbers
		Random rng = new Random();
		for(int i = 0; i < count; ++i) {
			ships.add(new Ship(0, 0, rng.nextInt(2) + 1, rng.nextInt(maxSize-1) + 1));
		}
	}

	void Print() {
		Logger.PrintS(LOGLEVEL.NORMAL, "Number of ships: ${ships.length}");
		for(var ship in ships) {
			Logger.PrintS(LOGLEVEL.VERBOSE, ship.dimensions);
		}
	}

	String toString() {
		String message = "[";
		int i = 0;
		for(var ship in ships) {
			message += ship.dimensions.width.toString();
			message += 'x';
			message += ship.dimensions.height.toString();
			if(i++ < ships.length-1) {
				message += ', ';
			}
		}
		return message + ']';
	}
}

